<template>
  <p class="fr-mb-2w">
    <RequiredFields />
  </p>
  <form
    ref="form"
    novalidate
    @submit.prevent="onSubmit"
  >
    <fieldset
      class="fr-fieldset fr-grid-row fr-grid-row--gutters"
      aria-labelledby="structure-information-legend"
    >
      <div class="fr-col-12">
        <VeeInput
          name="name"
          :label="structureFieldLabels.name"
          required
        />
      </div>

      <div class="fr-col-12">
        <VeeInput
          name="address"
          :label="structureFieldLabels.address"
          required
        />
      </div>

      <div class="fr-col-4">
        <VeeInput
          name="zipcode"
          :label="structureFieldLabels.zipcode"
          required
        />
      </div>
      <div class="fr-col-8">
        <VeeInput
          name="city"
          :label="structureFieldLabels.city"
          required
        />
      </div>

      <div class="fr-col-12">
        <VeeInput
          name="phone"
          :label="structureFieldLabels.phone"
          type="tel"
          required
        />
      </div>

      <div class="fr-col-12">
        <VeeInput
          name="email"
          :label="structureFieldLabels.email"
          required
          type="email"
        />
      </div>

      <div
        id="dpo-scroll"
        clas="fr-col-12 "
      >
        <div class="fr-p-3v fr-mt-1w">
          <h3 class="fr-mb-0 fr-text--lg grey">
            Personne référente à la protection des données (DPO)&nbsp;:
          </h3>
        </div>

        <div class="fr-p-3v">
          <VeeInput
            name="dpoFirstName"
            :label="structureFieldLabels.dpoFirstName"
            required
          />
        </div>

        <div class="fr-p-3v">
          <VeeInput
            name="dpoLastName"
            :label="structureFieldLabels.dpoLastName"
            required
          />
        </div>

        <div class="fr-p-3v">
          <VeeInput
            name="dpoEmail"
            :label="structureFieldLabels.dpoEmail"
            required
            type="email"
          />
        </div>
      </div>
    </fieldset>

    <ul
      class="fr-btns-group fr-btns-group--inline-md fr-btns-group--right fr-mt-3w"
    >
      <li>
        <button
          class="fr-btn fr-btn--secondary fr-mb-0"
          type="button"
          @click="modal.close"
        >
          Annuler
        </button>
      </li>
      <li>
        <button
          class="fr-btn fr-mb-0"
          type="submit"
        >
          Valider
        </button>
      </li>
    </ul>
  </form>
</template>

<script lang="ts" setup>
  import { structureFieldLabels } from '~/client/labels'
  import type { StructureInfo } from '~/components/Structure/types'
  import {
    EditStructureInfoInput,
    editStructureInfoSchema
  } from '~/server/schema'

  const props = defineProps<{
    structure: StructureInfo
    validate: (values: EditStructureInfoInput) => void
    dpoScroll?: boolean
  }>()

  const modal = useModal()

  const form = ref<HTMLFormElement | null>(null)

  const { handleSubmit } = useForm<EditStructureInfoInput>({
    validationSchema: toTypedSchema(editStructureInfoSchema),
    initialValues: {
      name: props.structure.name,
      zipcode: props.structure.zipcode,
      city: props.structure.city,
      address: props.structure.address,
      phone: props.structure.phone,
      email: props.structure.email,
      dpoEmail: props.structure.dpoEmail || undefined,
      dpoFirstName: props.structure.dpoFirstName || undefined,
      dpoLastName: props.structure.dpoLastName || undefined
    }
  })

  const { onSubmit } = useCatchFormErrors(handleSubmit, values =>
    props.validate(values)
  )
  onMounted(() => {
    const dpoElement = document.getElementById('dpo-scroll')
    if (dpoElement && props.dpoScroll) {
      dpoElement.scrollIntoView({
        block: 'start',
        inline: 'nearest'
      })
    }
  })
</script>

<style scoped lang="css">
  .grey {
    color: var(--text-default-grey);
  }
</style>
